# Tables ## List tables in structured sheet `client.StructuredSheets.Tables.List(ctx, structuredSheetID, query) (*CursorIDPage[TableResponse], error)` **get** `/v1/structured-sheets/{structured_sheet_id}/tables` List all tables extracted from the structured sheet. Only available when conversion status is 'completed'. ### Parameters - `structuredSheetID string` The unique identifier of the structured sheet conversion. - `query StructuredSheetTableListParams` - `After param.Field[string]` A cursor for pagination. Use the `last_id` from a previous response to fetch the next page of results. - `Limit param.Field[int64]` Maximum number of tables to return per page. ### Returns - `type TableResponse struct{…}` Response representing a table extracted from a structured sheet. This is returned from GET (retrieve) and list table endpoints. Table names use a composite format: {normalized_sheet_name}__{table_name}. - `ID string` The unique identifier for this table. - `CreatedAt Time` The timestamp when this table was created. - `Name string` Composite table name: {normalized_sheet_name}__{table_name}. Uses lowercase snake_case. Aggregation tables end with '__aggregations'. Two special metadata tables exist per structured sheet: '__deeptable_workbook_metadata' (workbook provenance info) and '__deeptable_table_overview' (summary of all tables). Example: 'staffing__head_count' or 'staffing__head_count__aggregations'. - `Object Table` The object type, which is always 'table'. - `const TableTable Table = "table"` - `SheetName string` The original Excel sheet name this table came from. - `StructuredSheetID string` The ID of the structured sheet this table belongs to. - `Type TableResponseType` The type of table (relational, aggregation, tableless, or metadata). - `const TableResponseTypeRelational TableResponseType = "relational"` - `const TableResponseTypeAggregation TableResponseType = "aggregation"` - `const TableResponseTypeTableless TableResponseType = "tableless"` - `const TableResponseTypeMetadata TableResponseType = "metadata"` ### Example ```go package main import ( "context" "fmt" "github.com/deeptable-com/deeptable-go" "github.com/deeptable-com/deeptable-go/option" ) func main() { client := deeptable.NewClient( option.WithAPIKey("My API Key"), ) page, err := client.StructuredSheets.Tables.List( context.TODO(), "ss_01kfxgjd94fn9stqm42nejb627", deeptable.StructuredSheetTableListParams{ }, ) if err != nil { panic(err.Error()) } fmt.Printf("%+v\n", page) } ``` #### Response ```json { "data": [ { "id": "tbl_01kfxgjd94fn9stqm45rqr2pnz", "created_at": "2026-01-15T10:35:00Z", "name": "staffing__head_count", "object": "table", "sheet_name": "Staffing", "structured_sheet_id": "ss_01kfxgjd94fn9stqm42nejb627", "type": "relational" }, { "id": "tbl_02abc2def3ghjkmnpqrs4uvwxz", "created_at": "2026-01-15T10:35:00Z", "name": "staffing__head_count__aggregations", "object": "table", "sheet_name": "Staffing", "structured_sheet_id": "ss_01kfxgjd94fn9stqm42nejb627", "type": "aggregation" } ], "has_more": false, "object": "list", "first_id": "tbl_01kfxgjd94fn9stqm45rqr2pnz", "last_id": "tbl_02abc2def3ghjkmnpqrs4uvwxz" } ``` ## Retrieve a table `client.StructuredSheets.Tables.Get(ctx, tableID, query) (*TableResponse, error)` **get** `/v1/structured-sheets/{structured_sheet_id}/tables/{table_id}` Get details of a specific table extracted from the structured sheet. Only available when conversion status is 'completed'. ### Parameters - `tableID string` The unique identifier of the table. - `query StructuredSheetTableGetParams` - `StructuredSheetID param.Field[string]` The unique identifier of the structured sheet conversion. ### Returns - `type TableResponse struct{…}` Response representing a table extracted from a structured sheet. This is returned from GET (retrieve) and list table endpoints. Table names use a composite format: {normalized_sheet_name}__{table_name}. - `ID string` The unique identifier for this table. - `CreatedAt Time` The timestamp when this table was created. - `Name string` Composite table name: {normalized_sheet_name}__{table_name}. Uses lowercase snake_case. Aggregation tables end with '__aggregations'. Two special metadata tables exist per structured sheet: '__deeptable_workbook_metadata' (workbook provenance info) and '__deeptable_table_overview' (summary of all tables). Example: 'staffing__head_count' or 'staffing__head_count__aggregations'. - `Object Table` The object type, which is always 'table'. - `const TableTable Table = "table"` - `SheetName string` The original Excel sheet name this table came from. - `StructuredSheetID string` The ID of the structured sheet this table belongs to. - `Type TableResponseType` The type of table (relational, aggregation, tableless, or metadata). - `const TableResponseTypeRelational TableResponseType = "relational"` - `const TableResponseTypeAggregation TableResponseType = "aggregation"` - `const TableResponseTypeTableless TableResponseType = "tableless"` - `const TableResponseTypeMetadata TableResponseType = "metadata"` ### Example ```go package main import ( "context" "fmt" "github.com/deeptable-com/deeptable-go" "github.com/deeptable-com/deeptable-go/option" ) func main() { client := deeptable.NewClient( option.WithAPIKey("My API Key"), ) tableResponse, err := client.StructuredSheets.Tables.Get( context.TODO(), "tbl_01kfxgjd94fn9stqm45rqr2pnz", deeptable.StructuredSheetTableGetParams{ StructuredSheetID: "ss_01kfxgjd94fn9stqm42nejb627", }, ) if err != nil { panic(err.Error()) } fmt.Printf("%+v\n", tableResponse.ID) } ``` #### Response ```json { "id": "tbl_01kfxgjd94fn9stqm45rqr2pnz", "created_at": "2026-01-15T10:35:00Z", "name": "staffing__head_count", "object": "table", "sheet_name": "Staffing", "structured_sheet_id": "ss_01kfxgjd94fn9stqm42nejb627", "type": "relational" } ``` ## Download table data `client.StructuredSheets.Tables.Download(ctx, tableID, params) (*Response, error)` **get** `/v1/structured-sheets/{structured_sheet_id}/tables/{table_id}/download` Download the table data in the specified format. Available formats: - `parquet`: Apache Parquet columnar format (recommended for data analysis) - `csv`: Comma-separated values (compatible with any spreadsheet application) ### Parameters - `tableID string` The unique identifier of the table. - `params StructuredSheetTableDownloadParams` - `StructuredSheetID param.Field[string]` Path param: The unique identifier of the structured sheet conversion. - `Format param.Field[StructuredSheetTableDownloadParamsFormat]` Query param: The format to download the table data in. - `const StructuredSheetTableDownloadParamsFormatParquet StructuredSheetTableDownloadParamsFormat = "parquet"` - `const StructuredSheetTableDownloadParamsFormatCsv StructuredSheetTableDownloadParamsFormat = "csv"` ### Returns - `type StructuredSheetTableDownloadResponse interface{…}` ### Example ```go package main import ( "context" "fmt" "github.com/deeptable-com/deeptable-go" "github.com/deeptable-com/deeptable-go/option" ) func main() { client := deeptable.NewClient( option.WithAPIKey("My API Key"), ) response, err := client.StructuredSheets.Tables.Download( context.TODO(), "tbl_01kfxgjd94fn9stqm45rqr2pnz", deeptable.StructuredSheetTableDownloadParams{ StructuredSheetID: "ss_01kfxgjd94fn9stqm42nejb627", Format: deeptable.StructuredSheetTableDownloadParamsFormatParquet, }, ) if err != nil { panic(err.Error()) } fmt.Printf("%+v\n", response) } ``` ## Domain Types ### Table Response - `type TableResponse struct{…}` Response representing a table extracted from a structured sheet. This is returned from GET (retrieve) and list table endpoints. Table names use a composite format: {normalized_sheet_name}__{table_name}. - `ID string` The unique identifier for this table. - `CreatedAt Time` The timestamp when this table was created. - `Name string` Composite table name: {normalized_sheet_name}__{table_name}. Uses lowercase snake_case. Aggregation tables end with '__aggregations'. Two special metadata tables exist per structured sheet: '__deeptable_workbook_metadata' (workbook provenance info) and '__deeptable_table_overview' (summary of all tables). Example: 'staffing__head_count' or 'staffing__head_count__aggregations'. - `Object Table` The object type, which is always 'table'. - `const TableTable Table = "table"` - `SheetName string` The original Excel sheet name this table came from. - `StructuredSheetID string` The ID of the structured sheet this table belongs to. - `Type TableResponseType` The type of table (relational, aggregation, tableless, or metadata). - `const TableResponseTypeRelational TableResponseType = "relational"` - `const TableResponseTypeAggregation TableResponseType = "aggregation"` - `const TableResponseTypeTableless TableResponseType = "tableless"` - `const TableResponseTypeMetadata TableResponseType = "metadata"`